//--------------------------------------------------
// Commander armor
//--------------------------------------------------

$ArmorType[Male, iCommanderArmor] = commanderarmor;
$ArmorType[Female, iCommanderArmor] = commanderarmor;
$ArmorName[commanderarmor] = iCommanderArmor;
$InvList[iCommanderArmor] = 1;

ItemData iCommanderArmor
{
   heading = "aSpecialist";
	description = "Commander";
	className = "Armor";
	price = 600;
};

PlayerData commanderarmor
{

   // === Patch Ver 1.1 additions ===
   horzVelClamp = 20;
   validateShape = true;
   // ========================

   className = "Armor";
   shapeFile = "harmor";
   flameShapeName = "hflame";
   shieldShapeName = "shield";
   damageSkinData = "armorDamageSkins";
   debrisId = playerDebris;
   shadowDetailMask = 1;

   visibleToSensor = True;
	mapFilter = 1;
	mapIcon = "M_player";

   maxJetSideForceFactor = 0.8;
   maxJetForwardVelocity = 8;  // was 12 (RJC)
   minJetEnergy = 1;
   jetForce = 405;
   jetEnergyDrain = 1.1;

	maxDamage = 1.32;
   maxForwardSpeed = 3.5; // was 5.0 (RJC)
   maxBackwardSpeed = 3.0; // was 4.0 (RJC)
   maxSideSpeed = 3.0; // was 4.0 (RJC)
   groundForce = 25 * 18.0; // was 35 * 18.0 (RJC)
   groundTraction = 4.5;
   mass = 18.0;
	maxEnergy = 110;
   drag = 1.0;
   density = 2.5;
   canCrouch = false;

	minDamageSpeed = 25;
	damageScale = 0.006;

   jumpImpulse = 150;
   jumpSurfaceMinDot = 0.2;

   // animation data:
   // animation name, one shot, exclude, direction,
	// firstPerson, chaseCam, thirdPerson, signalThread

   // movement animations:
   animData[0]  = { "root", none, 1, true, true, true, false, 0 };
   animData[1]  = { "run", none, 1, true, false, true, false, 3 };
   animData[2]  = { "runback", none, 1, true, false, true, false, 3 };
   animData[3]  = { "side left", none, 1, true, false, true, false, 3 };
   animData[4]  = { "side left", none, -1, true, false, true, false, 3 };
   animData[5] = { "jump stand", none, 1, true, false, true, false, 3 };
   animData[6] = { "jump run", none, 1, true, false, true, false, 3 };
   animData[7] = { "crouch root", none, 1, true, true, true, false, 3 };
   animData[8] = { "crouch root", none, 1, true, true, true, false, 3 };
   animData[9] = { "crouch root", none, -1, true, true, true, false, 3 };
   animData[10] = { "crouch forward", none, 1, true, false, true, false, 3 };
   animData[11] = { "crouch forward", none, -1, true, false, true, false, 3 };
   animData[12] = { "crouch side left", none, 1, true, false, true, false, 3 };
   animData[13] = { "crouch side left", none, -1, true, false, true, false, 3 };
   animData[14]  = { "fall", none, 1, true, true, true, false, 3 };
   animData[15]  = { "landing", SoundLandOnGround, 1, true, false, false, false, 3 };
   animData[16]  = { "landing", SoundLandOnGround, 1, true, false, false, false, 3 };
   animData[17]  = { "tumble loop", none, 1, true, false, false, false, 3 };
   animData[18]  = { "tumble end", none, 1, true, false, false, false, 3 };
   animData[19] = { "jet", none, 1, true, true, true, false, 3 };

   // misc. animations:
   animData[20] = { "PDA access", none, 1, true, false, false, false, 3 };
   animData[21] = { "throw", none, 1, true, false, false, false, 3 };
   animData[22] = { "flyer root", none, 1, false, false, false, false, 3 };
   animData[23] = { "apc root", none, 1, true, true, true, false, 3 };
   animData[24] = { "apc pilot", none, 1, false, false, false, false, 3 };
   
   // death animations:
   animData[25] = { "crouch die", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[26] = { "die chest", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[27] = { "die head", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[28] = { "die grab back", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[29] = { "die right side", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[30] = { "die left side", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[31] = { "die leg left", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[32] = { "die leg right", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[33] = { "die blown back", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[34] = { "die spin", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[35] = { "die forward", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[36] = { "die forward kneel", SoundPlayerDeath, 1, false, false, false, false, 4 };
   animData[37] = { "die back", SoundPlayerDeath, 1, false, false, false, false, 4 };

   // signal moves:
	animData[38] = { "sign over here",  none, 1, true, false, false, false, 2 };
   animData[39] = { "sign point", none, 1, true, false, false, true, 1 };
   animData[40] = { "sign retreat",none, 1, true, false, false, false, 2 };
   animData[41] = { "sign stop", none, 1, true, false, false, true, 1 };
   animData[42] = { "sign salut", none, 1, true, false, false, true, 1 }; 

    // celebraton animations:
   animData[43] = { "celebration 1", none, 1, true, false, false, false, 2 };
   animData[44] = { "celebration 2", none, 1, true, false, false, false, 2 };
   animData[45] = { "celebration 3", none, 1, true, false, false, false, 2 };

    // taunt anmations:
   animData[46] = { "taunt 1", none, 1, true, false, false, false, 2 };
   animData[47] = { "taunt 2", none, 1, true, false, false, false, 2 };

    // poses:
   animData[48] = { "pose kneel", none, 1, true, false, false, true, 1 };
   animData[49] = { "pose stand", none, 1, true, false, false, true, 1 };

	// Bonus wave
   animData[50] = { "wave", none, 1, true, false, false, true, 1 };

   jetSound = SoundJetHeavy;

   rFootSounds = 
   {
     SoundHFootRSoft,
     SoundHFootRHard,
     SoundHFootRSoft,
     SoundHFootRHard,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRHard,
     SoundHFootRSnow,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRSoft,
     SoundHFootRSoft
  }; 
   lFootSounds =
   {
      SoundHFootLSoft,
      SoundHFootLHard,
      SoundHFootLSoft,
      SoundHFootLHard,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLHard,
      SoundHFootLSnow,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLSoft,
      SoundHFootLSoft
   };

   footPrints = { 4, 5 };

   boxWidth = 0.8;
   boxDepth = 0.8;
   boxNormalHeight = 2.6;

   boxNormalHeadPercentage  = 0.70;
   boxNormalTorsoPercentage = 0.45;

   boxHeadLeftPercentage  = 0.48;
   boxHeadRightPercentage = 0.70;
   boxHeadBackPercentage  = 0.48;
   boxHeadFrontPercentage = 0.60;
};

$DamageScale[commanderarmor, $LandingDamageType] = 1.0;
$DamageScale[commanderarmor, $ImpactDamageType] = 1.0;
$DamageScale[commanderarmor, $CrushDamageType] = 1.0;
$DamageScale[commanderarmor, $BulletDamageType] = 0.4; // was 0.6
$DamageScale[commanderarmor, $PlasmaDamageType] = 0.3; // was 0.4
$DamageScale[commanderarmor, $EnergyDamageType] = 0.7;
$DamageScale[commanderarmor, $ExplosionDamageType] = 0.4; // was 0.6
$DamageScale[commanderarmor, $MissileDamageType] = 0.6;
$DamageScale[commanderarmor, $DebrisDamageType] = 0.8;
$DamageScale[commanderarmor, $ShrapnelDamageType] = 0.6; // was 0.8
$DamageScale[commanderarmor, $LaserDamageType] = 0.6;
$DamageScale[commanderarmor, $MortarDamageType] = 0.5; // was 0.7
$DamageScale[commanderarmor, $BlasterDamageType] = 0.7;
$DamageScale[commanderarmor, $ElectricityDamageType] = 1.0;
$DamageScale[commanderarmor, $MineDamageType] = 0.8;
$DamageScale[commanderarmor, $PoisonGasDamageType] = 0.9;
$DamageScale[commanderarmor, $RadiationDamageType] = 0.8;
$DamageScale[commanderarmor, $EMPDamageType] = 1.0;
$DamageScale[commanderarmor, $NullDamageType] = 0.0;
$DamageScale[commanderarmor, $FireDamageType] = 0.6;
$DamageScale[commanderarmor, $AcidDamageType] = 1.0;
$DamageScale[commanderarmor, $BlindDamageType] = 1.0;
$DamageScale[commanderarmor, $SniperRifleDamageType] = 0.8;
$DamageScale[commanderarmor, $ShotgunDamageType] = 0.5;
$DamageScale[commanderarmor, $FlakDamageType] = 0.7;
$DamageScale[commanderarmor, $ExplosiveGatDamageType] = 0.6;
$DamageScale[commanderarmor, $ArtilleryShellDamageType] = 0.8;
$DamageScale[commanderarmor, $TimedExplosiveDamageType] = 0.8;
$DamageScale[commanderarmor, $RemoteBombDamageType] = 0.8;
$DamageScale[commanderarmor, $HandDamageType] = 0.7;

$ItemMax[commanderarmor, Blaster] = 1;
$ItemMax[commanderarmor, Chaingun] = 1;
$ItemMax[commanderarmor, Disclauncher] = 1;
$ItemMax[commanderarmor, GrenadeLauncher] = 1;
$ItemMax[commanderarmor, Mortar] = 1;
$ItemMax[commanderarmor, PlasmaGun] = 1;
$ItemMax[commanderarmor, LaserRifle] = 0;
$ItemMax[commanderarmor, EnergyRifle] = 1;
$ItemMax[commanderarmor, TargetingLaser] = 1;
$ItemMax[commanderarmor, MineAmmo] = 3;
$ItemMax[commanderarmor, Grenade] = 5;
$ItemMax[commanderarmor, Beacon] = 3;

$ItemMax[commanderarmor, BulletAmmo] = 200;
$ItemMax[commanderarmor, PlasmaAmmo] = 50;
$ItemMax[commanderarmor, DiscAmmo] = 15;
$ItemMax[commanderarmor, GrenadeAmmo] = 15;
$ItemMax[commanderarmor, MortarAmmo] = 10;

$ItemMax[commanderarmor, EnergyPack] = 1;
$ItemMax[commanderarmor, RepairPack] = 1;
$ItemMax[commanderarmor, ShieldPack] = 1;
$ItemMax[commanderarmor, SensorJammerPack] = 1;
$ItemMax[commanderarmor, MotionSensorPack] = 1;
$ItemMax[commanderarmor, PulseSensorPack] = 1;
$ItemMax[commanderarmor, DeployableSensorJammerPack] = 1;
$ItemMax[commanderarmor, CameraPack] = 1;
$ItemMax[commanderarmor, TurretPack] = 1;
$ItemMax[commanderarmor, AmmoPack] = 1;
$ItemMax[commanderarmor, RepairKit] = 1;
$ItemMax[commanderarmor, DeployableInvPack] = 1;
$ItemMax[commanderarmor, DeployableAmmoPack] = 1;

$MaxWeapons[commanderarmor] = 6;

